<template>
  <div id="chat">
    <div ref="chatContainer" class="chat-container" @scroll="onScroll">
      <message
        :messages="groupMessages"
        @imageLoad="scrollToEnd"
        @newMessage="scrollToEnd"
      />
      <p
        v-if="!chatId && user.role === 'facilitator'"
        class="title text-center align-bottom"
      >
        Please choose a conversation.
      </p>
    </div>
    <div class="typer px-2 py-0">
      <v-row justify="center">
        <v-col md="10" lg="8" sm="12">
          <v-text-field
            :disabled="!groupChatId"
            v-model="content"
            outlined
            label="Enter new message"
            @keyup.enter="sendMessage"
          >
            <v-icon slot="append" medium @click="sendMessage"
              >fas fa-paper-plane</v-icon
            >
          </v-text-field>
        </v-col>
      </v-row>
    </div>
  </div>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import Message from '../Message'

export default {
  components: {
    message: Message
  },
  props: {
    id: {
      type: String
    },
    chatId: {
      type: String,
      required: false,
      default: null
    }
  },
  data() {
    return {
      content: '',
      chatMessages: [],
      currentRef: {},
      loading: false,
      totalChatHeight: 0,
      sending: false
    }
  },
  computed: {
    groupChatId() {
      return this.$store.state.conversations.groupChatId
    },
    user() {
      return this.$store.state.authentication.user
    },
    ...mapState('authentication', ['user']),
    ...mapState('conversations', ['groupChatId', 'groupMessages']),
    onChildAdded() {
      const that = this
      const onChildAdded = function(snapshot, newMessage = true) {
        const message = snapshot.val()
        message.key = snapshot.key
        /*eslint-disable */
        var urlPattern = /(\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/gi
        /* eslint-enable */
        message.content = message.content
          .replace(/&/g, '&amp;')
          .replace(/</g, '&lt;')
          .replace(/>/g, '&gt;')
          .replace(/"/g, '&quot;')
          .replace(/'/g, '&#039;')
        message.content = message.content.replace(
          urlPattern,
          "<a href='$1'>$1</a>"
        )
        if (!newMessage) {
          that.chatMessages.unshift(that.processMessage(message))
          that.scrollTo()
        } else {
          that.chatMessages.push(that.processMessage(message))
          that.scrollToEnd()
        }
      }
      return onChildAdded
    }
  },
  watch: {
    '$route.params.id': () => {
      this.currentRef.off('child_added', this.onChildAdded)
      this.loadChat()
    },
    chatId: {
      async handler(chatId) {
        if (chatId) {
          await this.addGroupChatId(chatId)
          this.$store
            .dispatch('conversations/getConversation')
            .then(() => {
              // this.messages.push(res)
            })
            .catch(err => {
              console.log(err)
            })
        }
      }
      // messages: {
      //   handler(message) {
      //     console.log(message)
      //   }
      // }
    }
  },
  mounted() {
    this.loadChat()
    this.loading = true
    if (this.user.role === 'user') {
      this.$store
        .dispatch('conversations/getConversation')
        .then(() => {
          this.loading = false
        })
        .catch(() => {
          this.loading = false
        })
    }
  },
  methods: {
    ...mapMutations('conversations', ['addGroupChatId', 'addMessage']),
    loadChat() {
      this.totalChatHeight = this.$refs.chatContainer.scrollHeight
      this.loading = false
    },
    onScroll() {
      const scrollValue = this.$refs.chatContainer.scrollTop
      if (scrollValue < 100 && !this.loading) {
        this.totalChatHeight = this.$refs.chatContainer.scrollHeight
        this.loading = true
        const currentTopMessage = this.chatMessages[0]
        if (currentTopMessage === undefined) {
          this.loading = false
        }
      }
    },
    processMessage(message) {
      /*eslint-disable */
      var imageRegex = /([^\s\']+).(?:jpg|jpeg|gif|png)/i
      /* eslint-enable */
      if (imageRegex.test(message.content)) {
        ;[message.image] = imageRegex.exec(message.content)
      }
      return message
    },
    async sendMessage() {
      if (this.content !== '') {
        this.messageContent = this.content
        this.content = ''
        this.sending = true
        const message = {
          messageBody: this.messageContent,
          groupChatId: this.groupChatId,
          senderReceiver: `${this.user.id}-${this.groupChatId}`,
          userId: this.user.id
        }
        await this.$store.commit('conversations/addMessage', message)
        await this.$store
          .dispatch('conversations/addMessageToGroup', message)
          .then(() => {
            this.sending = false
            this.messageContent = ''
          })
          .catch(err => {
            this.sending = false
            this.messageContent = ''
            console.log(err)
          })
      }
    },
    scrollToEnd() {
      this.$nextTick(() => {
        const container = this.$el.querySelector('.chat-container')
        container.scrollTop = container.scrollHeight
      })
    },
    scrollTo() {
      this.$nextTick(() => {
        const currentHeight = this.$refs.chatContainer.scrollHeight
        const difference = currentHeight - this.totalChatHeight
        const container = this.$el.querySelector('.chat-container')
        container.scrollTop = difference
      })
    }
  }
}
</script>

<style lang="scss">
#chat {
  width: 100%;
  // position: fixed;
  height: 100%;
  position: relative;
  display: flex;
  flex-direction: column;
  background-color: #f9f9f9;
}
.scrollable {
  overflow-y: auto;
  height: 90vh;
}
.typer {
  display: block;
  width: 100%;
  border-top: solid 1px #e0e0e0;
  position: absolute;
  bottom: 0;
  height: 120px;
}

.chat-container {
  transition: height cubic-bezier(0.25, 0.46, 0.45, 0.94) 0.25s;
  position: relative;
  overflow: hidden;
  background-color: #fff;
  overflow-y: scroll;
  overflow-x: hidden;
  height: calc(100% - 120px);
}
.message {
  margin-bottom: 3px;
}
.message.own {
  text-align: right;
}
.message.own .content {
  background-color: lightskyblue;
  text-align: left;
}
.chat-container .username {
  font-size: 18px;
  font-weight: bold;
}
.chat-container .content {
  padding: 8px;
  background-color: lightgreen;
  border-radius: 10px;
  display: inline-block;
  // box-shadow: 0 1px 3px 0 rgba(0,0,0,0.2), 0 1px 1px 0 rgba(0,0,0,0.14), 0 2px 1px -1px rgba(0,0,0,0.12);
  max-width: 50%;
  word-wrap: break-word;
}
@media (max-width: 480px) {
  .chat-container .content {
    max-width: 100%;
  }
}
</style>
